/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ryuuji.servlet.curso.asignatura.actividad;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.GregorianCalendar;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import logica.Listas;
import logica.Search;
import orm.Actividad;
import orm.Asignatura;
import orm.Curso;

/**
 *
 * @author ryuuji
 */
@WebServlet(name = "ActividadServlet", urlPatterns = {"/ActividadServlet"})
public class ActividadServlet extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        response.setHeader("Cache-Control", "no-cache, no-store, must-revalidate"); // HTTP 1.1.
        response.setHeader("Pragma", "no-cache"); // HTTP 1.0.
        response.setHeader("Expires", "0"); // Proxies.

        String cursoSelected = request.getParameter("cursoSelected");
        Curso curso;
        if (cursoSelected != null) {
            curso = Search.buscarCurso(Integer.parseInt(cursoSelected.split("-")[0]), cursoSelected.split("-")[1]);
        } else {
            Curso[] cursos = Search.buscarCursos();
            if (cursos != null) {
                curso = cursos[0];
            } else {
                curso = null;
            }
        }
        String asignaturaSelected = request.getParameter("asignaturaSelected");
        Asignatura asignatura;
        if (asignaturaSelected != null) {
            if (curso != null) {
                asignatura = Search.buscarAsignatura(asignaturaSelected, curso);
            } else {
                asignatura = null;
            }
        } else {
            if (curso != null) {
                Asignatura[] asignaturas = Search.buscarAsignaturas(curso);
                if (asignaturas != null) {
                    asignatura = asignaturas[0];
                } else {
                    asignatura = null;
                }
            } else {
                asignatura = null;
            }
        }

        String[] cursos = Listas.listaCursos();
        String[] asignaturas;
        if (curso != null) {
            asignaturas = Listas.listaAsignaturas(curso);
        } else {
            asignaturas = null;
        }

        Actividad[] actividades;
        if (asignatura != null) {
            actividades = Search.buscarActividades(asignatura);
        } else {
            actividades = null;
        }

        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        Date date = GregorianCalendar.getInstance().getTime();

        request.setAttribute("today", format.format(date));
        request.setAttribute("asignaturas", asignaturas);
        request.setAttribute("cursos", cursos);
        request.setAttribute("cursoSelected", cursoSelected);
        request.setAttribute("asignaturaSelected", asignaturaSelected);
        request.setAttribute("actividades", actividades);
        
        request.getRequestDispatcher("actividades.jsp").forward(request, response);
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
